%%%%Homework 6 Problem 1%%%%
%%%%Calculate OLA error%%%%%
%%%%%%%%%%ECE 537%%%%%%%%%%%
%%%%%by Geoffrey Herman%%%%%

%%%%constants%%%%%
T = 1/(2*10^4);
beta = 10.5;
L = 128;
N = 1024;
w = kaiser(L,beta)'; %create kaiser window
W0 = sum(w);

%%%%%%%%%Part a%%%%%%%%%
R = L/4; %decimation parameter
numIters = (N-1)*R + L; %maximum value of t
e = zeros(1,numIters); %create empty error vector
for t = 1:numIters
    for n = 0:N-1
        if ((t-n*R) >= 1 && (t-n*R) <= L) %w(t-nR) = 0 outside of range
            e(1,t) = w(1,t-n*R) + e(1,t); %calculate summation
        end
    end
end
e = e.*R./W0-1; %scale the summation to find the error
plot([0:T:(numIters-1)*T],e); %plot error over all t
title('e(t) for R = L/4');
xlabel('time [s]'); ylabel('error');

%%%%%%%%Part b%%%%%%%%%
figure;
e2 = e(L:N-1-L); %zoom in on error over L<t<N-1-L interval
plot([L*T:T:(N-1-L)*T],e2);
title('e(t) for R = L/4 for L<t<N-1-L');
xlabel('time [s]'); ylabel('error');

%%%%%%%Part c%%%%%%%%%%
figure;
R = L/2; %decimation parameter
numIters = (N-1)*R + L; %maximum value of t
e = zeros(1,numIters); %create empty error vector
for t = 1:numIters
    for n = 0:N-1
        if ((t-n*R) >= 1 && (t-n*R) <= L) %w(t-nR) = 0 outside of range
            e(1,t) = w(1,t-n*R) + e(1,t); %calculate summation
        end
    end
end
e = e.*R./W0-1; %scale the summation to find the error
plot([0:T:(numIters-1)*T],e); %plot error over all t
title('e(t) for R = L/2');
xlabel('time [s]'); ylabel('error');

figure;
e2 = e(L:N-1-L);%zoom in on error over L<t<N-1-L
plot([L*T:T:(N-1-L)*T],e2);
title('e(t) for R = L/2 for L<t<N-1-L');
xlabel('time [s]'); ylabel('error');

%Period is R*T