%%%%Homework 6 Problem 2%%%%
%%%%Simple Speech Codec%%%%%
%%%%%%%%%%ECE 537%%%%%%%%%%%
%%%%%by Geoffrey Herman%%%%%

[s,Fs] = wavread('WhenAllElse8k.wav');
plot([0:1/Fs:(length(s)-1)/Fs],s);
title('Original speech');
xlabel('time [s]');
shat(1,:) = s';
%%%%basic speech codec%%%%
for C = 10:10
    M = 15/C;
    b16 = sign(s'); %take sign of s
    smag = abs(s'); %find magnitude of s
    sroot = smag.^(1/C); %take the Cth root of smag
    squant = (fix(sroot*2^M))/2^M; %quantize sroot

    shat(C,:) = squant.^C.*b16; %decode squant and create shat
    figure; plot([0:1/Fs:(length(s)-1)/Fs],shat(C,:));
    title(['Compressed speech with ', num2str(C), 'th root']);
    xlabel('time [s]');

    figure; hist(log2(abs(shat(C,:))+10^-25),[-16:0]); %calculate histogram of speech samples
    title(['Histogram of compressed speech with ', num2str(C), 'th root']);

    figure;
    specgram(shat(C,:),256,Fs,window(@hamming,256),256/4); %spectrogram of speech signal
    title(['spectrogram of compressed speech with ', num2str(C), 'th root']);
    xlabel('time [s]');
    sound(shat(C,:),Fs);
end